> For the complete documentation index, see [llms.txt](https://docs.whereby.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.whereby.com/reference/core-sdk-reference/quick-start.md).

# Quick Start

1. Create client

```jsx
import { WherebyClient } from "@whereby.com/core";

const client = new WherebyClient();
const roomConnection = client.getRoomConnection();
const localMedia = client.getLocalMedia();
```

2. Join room

```jsx
 type JoinRoomOptions = {
	 roomUrl: string;
	 audio?: boolean;
	 video?: boolean;
 }
 
 async function joinRoom({roomUrl, audio = false, video = false}: JoinRoomOptions) {
 
 /** If sending media, you need to start local media before initialising, for example: 
        async function startLocalMedia(stream: MediaStream) {
	await localMedia.startMedia(stream);
		}
 **/
        roomConnection.initialize({
            localMediaOptions: {
                audio,
                video,
            },
            roomUrl,
        });
        
        try {
            await roomConnection.joinRoom();
        } catch(error) {
            console.error("Could not join room", error);
            return;
        }
   }
```

3. Subscribe to remote participants

```jsx
import { RemoteParticipantState } from "@whereby.com/core"

public subscribeToRemoteParticipants(callback: (participants: RemoteParticpantState) => void): () => void {
        return roomConnection.subscribeToRemoteParticipants(callback);
    }
```

4. Minimal sample: Join for 10 seconds and then leave

```javascript
import { WherebyClient, RemoteParticipantState } from "@whereby.com/core";

const client = new WherebyClient();
const roomConnection = client.getRoomConnection();
const localMedia = client.getLocalMedia();

function subscribeToRemoteParticipants(
  callback: (participants: RemoteParticipantState[]) => void
) {
  return roomConnection.subscribeToRemoteParticipants(callback);
}

async function main(roomUrl: string) {

  // start media here if passing in a stream
  roomConnection.initialize({
    localMediaOptions: { audio: false, video: false },
    roomUrl,
  });
  
  try {
    await roomConnection.joinRoom();
  } catch(error) {
    console.error("Could not join room", error);
    return;
  }       

  const unsubscribe = subscribeToRemoteParticipants((participants) => {
    console.log(
      "Participants",
      participants.map((p) => ({
        id: p.id,
        displayName: p.displayName,
      }))
    );
  });

  setTimeout(async () => {
    unsubscribe?.();
    await roomConnection.leaveRoom();
    await localMedia.stopMedia?.();
    console.log("Left room");
 
  }, 10000);
}
```

This demonstrates the most basic functionality of the library. From this example, you can go on to implement more advanced functionality that is explained in more detail in the next sections of the documentation:

* [API Reference](/reference/core-sdk-reference/api-reference.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.whereby.com/reference/core-sdk-reference/quick-start.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
